CON
  CMP_ADDRESS = $C0
OBJ
  I2C      : "I2C LowLevel"
PUB Init(SDA, SCL)  
  repeat 9
    I2C.i2cStop
  I2C.Initialize(SDA, SCL)              '     Initialize i2c MASTER in present COG
PUB GetVersion
  result := ReadReg($00) & $FF
  return
PUB GetBBearing                         ' Byte bearing 0-255
  result  := ReadReg($1) & $FF
  result := 255 - result                ' upside mounting
PUB GetWBearing : wBearing              ' Word bearing in 1/10 degree
  ReadReg($2)                           ' first read still in I2C Low Level
  wBearing := REadReg($3)  & $FFFF
'  wBearing := 3600 - wBearing           ' upside mounting
PUB GetHeading : heading                '  math angle (CCW from east) in 1/10 degree
  heading := GetWBearing
  heading := 900 - heading
  if heading < 0
    heading += 3600
PUB GetRoll
  result := ReadReg($05) & $FF
  return
PUB GetPitch
  result := ReadReg($04) & $FF
  return
  
PRI ReadReg(reg)
  I2C.i2cStart
  I2C.i2cWrite(CMP_ADDRESS | 0, 8)
  I2C.i2cWrite(reg, 8)
  I2C.i2cStart
  I2C.i2cWrite(CMP_ADDRESS | 1, 8)
  result := I2C.i2cRead(0, 8)
  return

PUB WriteReg(reg, value)
  I2C.i2cStart                         
  I2C.i2cWrite(CMP_ADDRESS | 0, 8)
  I2C.i2cWrite(reg, 8)
  I2C.i2cWrite(value, 8)
  I2C.i2cStop
  
PUB BusCheck
  result := I2C.testBus
  return
PUB Present
  result := I2C.devicePresent(CMP_ADDRESS)
  return

{{
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                  
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}}
  